import 'package:ui_sdk/StandardPage.dart';
import 'package:ui_sdk/NavigatorService.dart';
import 'package:ui_sdk/props/ApiResponse.dart';
import 'package:ui_sdk/props/StandardScreenResponse.dart';
import 'package:flutter/material.dart';
import 'package:http/http.dart' as http;
import 'package:ui_sdk/props/UikAction.dart';
import 'dart:convert';

import 'package:ui_sdk/utils/pubsub/localpubsub.dart';

void main() async {
  runApp(const MyApp());
}

class MyApp extends StatelessWidget {
  static final GlobalKey<NavigatorState> navigatorKey =
      GlobalKey<NavigatorState>();
  const MyApp({Key? key}) : super(key: key);

  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: HomePage().page,
      navigatorKey: NavigationService.navigatorKey,
    );
  }
}

class HomePage extends StandardPage {
  @override
  Future<ApiResponse> getData() {
    return fetchAlbum();
  }

  @override
  Set<String?> getActions() {
    Set<String?> actionList = Set();
    actionList.add("OPEN_WEB");
    actionList.add("OPEN_ROUTE");
    actionList.add("OPEN_CATEGORY");
    return actionList;
  }

  @override
  getPageCallBackForAction() {
    return of;
  }

  void of(UikAction uikAction) {
    print(uikAction);
    var context = NavigationService.navigatorKey.currentContext;
    print(context);
    String type = uikAction.tap.type;
    switch (type) {
      case "OPEN_WEB":
        {
          print("OPEN_WEB");
        }
        break;
      case "OPEN_ROUTE":
        {
          print("inside the case of open route");
        }
        break;
      case "OPEN_CATEGORY":
        {
          print("Inside OPEN_CATEGORY");
        }
        break;
      default:
        {
          print("default switch case :(");
        }
        break;
    }
    PubSub pubsub = PubSub();
    print("mainScreen ${pubsub.stack.top()}");
  }

  @override
  getPageContext() {
    return HomePage;
  }
}

Future<ApiResponse> fetchAlbum() async {
  final queryParameter = {
    "id": "eb5f37b2-ca34-40a1-83ba-cb161eb55e6e",
  };

  final response = await http.get(
    Uri.parse('https://demo6015657.mockable.io/homescreen'),
    headers: {
      "ngrok-skip-browser-warning": "value",
    },
  );

  print(response);

  if (response.statusCode == 200) {
    return ApiResponse.fromJson(jsonDecode(response.body));
  } else {
    throw Exception('Failed to load album');
  }
}
